require(GlobalDependencys:GetDependency("StandardBase"):GetPackageName())

--GAME VARS
fDefaultFOV = 85
fAdditionalFOV = 0
fAspectRatio = DisplayInfo:GetWidth() / DisplayInfo:GetHeight()
fDefaultAspectRatio = 1.777777791
--fDefaultAspectRatio = 1.33333
fFactor = 0.00872665

--ControlVars
bFixEnabled = true
bFOV = true
bAspect = true
bDOF = true
bFringe = true

--PROCESS VARS
Process_FriendlyName = Module:GetFriendlyName()
Process_WindowName = "*"
Process_ClassName = "*"
Process_EXEName = "CastingFrankStone-Win64-Shipping.exe"

--INJECTION BEHAVIOUR
InjectDelay = 500
WriteInterval = 100
SearchInterval = 100
SuspendThread = false

--Name                         Manual/Auto/Hybrid  		Steam/Origin/Any                IncludeFile:Configure;Enable;Periodic;Disable;
SupportedVersions = { 		
{"Automatically Detect",       "Hybrid",  			"Any",	                         "Configure_SignatureScan;Enable_Inject;Periodic;Disable_Inject;"},
}

function Init_Controls()

	DefaultControls.AddHeader("Header_FixesEnableDisable","Individual Fixes",245,70,210,17)
	
	DefaultControls.AddHeader("Header_FOV","In game FOV fine adjustment",15,70,210,17)	
	DefaultControls.AddFixedFOVSlider("FOVSlider","FOVSlider_Changed",55,100,125,35,0,70,0,1)
	
	FOVSlider:SetTickFrequency(10)
	FOVSlider:SetLabel1Text("-20")
	FOVSlider:SetLabel2Text("+50")

	DefaultControls.AddFixToggle("CKFOVFix_Enable","FOV fix","CKFOVFix_Changed",255,101,180,14)
	DefaultControls.AddFixToggle("CKARFix_Enable","Aspect ratio fix","CKARFix_Changed",255,121,180,14)
	DefaultControls.AddFixToggle("CKFRINGEFOVFix_Enable","Chromatic aberrations fix","CKFRINGEFix_Changed",255,141,180,14)
	DefaultControls.AddFixToggle("CKDOFFix_Enable","Depth of field fix","CKDOFFix_Changed",255,161,180,14)

end

function Configure_SignatureScan() 
	
	local tAddress = HackTool:AddAddress("FOV")
	
	if HackTool:SignatureScan("77 ?? 48 ?? ?? FF 90 ?? ?? ?? ?? F3 0F ?? ?? ?? 48",tAddress,PAGE_EXECUTE_READ,0x0b,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--CastingFrankStone-Win64-Shipping.exe+4CEE514 - 48 8B 01              - mov rax,[rcx]
		--CastingFrankStone-Win64-Shipping.exe+4CEE517 - FF 90 20 07 00 00     - call qword ptr [rax+00000720]
		--CastingFrankStone-Win64-Shipping.exe+4CEE51D - F3 0F 10 40 30        - movss xmm0,[rax+30]
		--CastingFrankStone-Win64-Shipping.exe+4CEE522 - 48 83 C4 28           - add rsp,28
		--CastingFrankStone-Win64-Shipping.exe+4CEE526 - C3                    - ret 
	end
	
	local tResultCount = HackTool:SignatureScanMulti("89 ?? ?? 8B ?? ?? 33 ?? ?? 83 ?? ?? 31 ?? ?? 8B ?? ?? 33 ?? ?? 83 ?? ?? 31 ?? ?? 48 ?? ?? ?? 0F ?? ?? ?? 88 ?? ?? 8B ?? ?? 48 83","ASPECTS",PAGE_EXECUTE_READ,0x0,Process_EXEName)
	
	if tResultCount ~= 2 then	
		return ErrorOccurred("Could not find ASPECTS injection point, " .. Process_FriendlyName .. 
							 " may have updated to a version that is no longer supported.\r\n\r\n" .. 
							 "Try selecting a different version and re-enable the fix."	)
	else
	
		local tAddress = HackTool:AddAddress("ASPECT", HackTool:GetAddress( string.format("ASPECTS%d",1) ))
		print( tAddress:GetInfo(TYPE_ADDRESS) )	
		--CastingFrankStone-Win64-Shipping.exe+10A8603 - 89 41 44              - mov [rcx+44],eax
		--CastingFrankStone-Win64-Shipping.exe+10A8606 - 8B 42 48              - mov eax,[rdx+48]
		--CastingFrankStone-Win64-Shipping.exe+10A8609 - 89 41 48              - mov [rcx+48],eax
		--CastingFrankStone-Win64-Shipping.exe+10A860C - 8B 41 4C              - mov eax,[rcx+4C]
		--CastingFrankStone-Win64-Shipping.exe+10A860F - 33 42 4C              - xor eax,[rdx+4C]
	end	
	
	local tAddress = HackTool:AddAddress("FRINGE") -- r.SceneColorFringeQuality
	
	if HackTool:SignatureScan("7F ?? 89 B3 ?? ?? ?? ?? 8B ?? ?? 39 05 ?? ?? ?? ?? 0F",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then	
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--b1-Win64-Shipping.exe+EA98935 - 48 8B 05 6C 0A E3 0E  - mov rax,[b1-Win64-Shipping.exe+1D8C93A8]
		--b1-Win64-Shipping.exe+EA9893C - 39 30                 - cmp [rax],esi
		--b1-Win64-Shipping.exe+EA9893E - 7F 06                 - jg b1-Win64-Shipping.exe+EA98946
		--b1-Win64-Shipping.exe+EA98940 - 89 B3 AC 1D 00 00     - mov [rbx+00001DAC],esi
		--b1-Win64-Shipping.exe+EA98946 - 8B 04 2F              - mov eax,[rdi+rbp]
	end
	
	local tAddress = HackTool:AddAddress("DOF") -- r.DepthOfFieldQuality
	
	if HackTool:SignatureScan("48 ?? ?? 8B ?? ?? E8 ?? ?? ?? ?? 48 ?? ?? 48 6B ?? ?? 48 8D",tAddress,PAGE_EXECUTE_READ,0x03,Process_EXEName) == 0 then	
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--CastingFrankStone-Win64-Shipping.exe+3593004 - 48 8B 05 7D 6A 77 05  - mov rax,[CastingFrankStone-Win64-Shipping.exe+8D09A88]
		--CastingFrankStone-Win64-Shipping.exe+359300B - 48 8B CB              - mov rcx,rbx
		--CastingFrankStone-Win64-Shipping.exe+359300E - 8B 78 04              - mov edi,[rax+04]
		--CastingFrankStone-Win64-Shipping.exe+3593011 - E8 AA B5 80 01        - call CastingFrankStone-Win64-Shipping.exe+4D9E5C0
		--CastingFrankStone-Win64-Shipping.exe+3593016 - 48 63 C8              - movsxd  rcx,eax
	end
		
	return true
end

function Enable_Inject()

	local Variables = HackTool:AllocateMemory("Variables",0)
	Variables:PushFloat("CompensatedFOV")
	Variables:PushFloat("FOVIn")
	Variables:PushFloat("FOVOut")
	Variables:PushFloat("AdditionalFOV")
	Variables:PushFloat("AspectRatio")
	Variables:PushFloat("ScreenRatio")
	Variables:PushFloat("factor")
	Variables:PushInt("Aspect")
	
	Variables:Allocate()
	Variables["FOVIn"]:WriteFloat(fDefaultFOV)
	Variables["FOVOut"]:WriteFloat(fDefaultFOV)
	Variables["AdditionalFOV"]:WriteFloat(fAdditionalFOV)
	Variables["AspectRatio"]:WriteFloat(fDefaultAspectRatio)
	Variables["ScreenRatio"]:WriteFloat(fAspectRatio)
	Variables["factor"]:WriteFloat(fFactor)
	
	ResolutionChanged()	
				
	local asm = [[	

		(codecave:jmp)FOV,FOV_cc:
			%originalcode%
			$$0 [(allocation)Variables->FOVIn],$$1					$ctx=1
			fld dword ptr [(allocation)Variables->FOVIn]
			cmp dword ptr [(allocation)Variables->Aspect],1
			jne regularFOV
			fmul dword ptr [(allocation)Variables->factor]
			fptan
			fstp st0
			fld dword ptr [(allocation)Variables->ScreenRatio]			
			fdiv dword ptr [(allocation)Variables->AspectRatio]
			fmulp st1,st0
			fld1
			fpatan
			fdiv dword ptr [(allocation)Variables->factor]
			fst dword ptr [(allocation)Variables->CompensatedFOV]
		regularFOV:
			fadd dword ptr [(allocation)Variables->AdditionalFOV]
			fstp dword ptr [(allocation)Variables->FOVOut]
			$$0 $$1,[(allocation)Variables->FOVOut]					$ctx=1
			jmp %returnaddress%
			%end%

		(codecave:jmp)ASPECT,ASPECT_cc:
			$$0 $$2,[(allocation)Variables->ScreenRatio]			$ctx=1
			%originalcode%
			jmp %returnaddress%
			%end%
						
		(codecave)DOF,DOF_cc:
			xor $$1,$$1														$ctx=1
			nop
			%end%

		(codecave)FRINGE,FRINGE_cc:
			nop
			nop
			%end%
			
	]]

	if HackTool:CompileAssembly(asm,"Fixes") == nil then
		return ErrorOccurred("Assembly compilation failed...")
	else
		Toggle_CodeCave("FOV_cc",bFOV)
		Toggle_CodeCave("ASPECT_cc",bAspect)
		Toggle_CodeCave("FRINGE_cc",bFringe)
		Toggle_CodeCave("DOF_cc",bDOF)
	end
			
	Write_FOV()
	Write_AspectRatio()
	
end

function Periodic()
	local Variables = HackTool:GetAllocation("Variables")
	
	if Variables and Variables["FOVIn"] and Variables["AdditionalFOV"] then
		local fCompensatedFOV = Variables["CompensatedFOV"]:ReadFloat()
		local fFOVIn = Variables["FOVIn"]:ReadFloat()
		local fFOVOut = Variables["FOVOut"]:ReadFloat()
		
		PluginViewport:AppendStatusMessage( string.format("\r\n===== Fix informations =====\r\nFOV In: %0.2f, Compensated FOV : %0.2f, FOV Out : %.02f", fFOVIn, fCompensatedFOV, fFOVOut))
	end
	
end

function FOVSlider_Changed(Sender)

	fAdditionalFOV = Sender:GetPosition() - 20
	lblFOVSlider.Caption:SetCaption( string.format("Value: %.0f",fAdditionalFOV) )
		
	Write_FOV()	
	ForceUpdate()

end

function Write_FOV()

	local Variables = HackTool:GetAllocation("Variables")
	if Variables and Variables["AdditionalFOV"] then
		if bFOV == true then
			Variables["AdditionalFOV"]:WriteFloat(fAdditionalFOV)
		else
			Variables["AdditionalFOV"]:WriteFloat(0)
		end
	end

end

function Write_AspectRatio()

	local Variables = HackTool:GetAllocation("Variables")
	if Variables and Variables["AspectRatio"] and Variables["CompensatedFOV"] and Variables["FOVIn"] then
		if bAspect == false then
			local fFOVIn = Variables["FOVIn"]:ReadFloat()
			Variables["CompensatedFOV"]:WriteFloat(fFOVIn)
			Variables["Aspect"]:WriteInt(0)
		else
			Variables["Aspect"]:WriteInt(1)
		end		
	end

end

function Disable_Inject()
	
	CleanUp()
	
end

function CKFOVFix_Changed(Sender)

	bFOV = Toggle_CheckFix(Sender)
	Write_FOV()
	Toggle_CodeCave("FOV_cc",bFOV)
	ForceUpdate()
	
end

function CKARFix_Changed(Sender)

	bAspect = Toggle_CheckFix(Sender)
	Write_AspectRatio()
	Toggle_CodeCave("ASPECT_cc",bAspect)
	ForceUpdate()
	
end

function CKFRINGEFix_Changed(Sender)

	bFringe = Toggle_CheckFix(Sender)
	Toggle_CodeCave("FRINGE_cc",bFringe)
	ForceUpdate()

end

function CKDOFFix_Changed(Sender)

	bDOF = Toggle_CheckFix(Sender)
	Toggle_CodeCave("DOF_cc",bDOF)
	ForceUpdate()
	
end

function ResolutionChanged() 

	SyncDisplayDetection()
	
end

function Init()

	Init_BaseControls()
	Init_Controls()

end

function DeInit()

	DisableFix()

end
